import QtQuick 2.0
import Sailfish.Silica 1.0

BackgroundItem {
    id: delegate
    width: parent.width;
    height: Theme.itemSizeExtraSmall
    Image {
        id: countryImage
        height: parent.height * 0.6
        fillMode: Image.PreserveAspectFit
        anchors.verticalCenter: parent.verticalCenter
        anchors.left: parent.left
        anchors.leftMargin: Theme.paddingLarge
        source: "../flags/"+alpha_2.toLowerCase()+".png"
    }

    Label {
        id: land
        anchors.verticalCenter: parent.verticalCenter
        anchors.left: countryImage.right
        anchors.leftMargin: Theme.paddingMedium
        anchors.right: count.left
        anchors.rightMargin: Theme.paddingMedium
        color: delegate.highlighted ? Theme.highlightColor : Theme.primaryColor
        font.pixelSize: Theme.fontSizeSmall
        text: radioBrowser.getCountryName(alpha_2)
    }
    Label {
        id: count
        anchors.verticalCenter: parent.verticalCenter
        anchors.right: parent.right
        anchors.rightMargin: Theme.paddingMedium
        color: delegate.highlighted ? Theme.highlightColor : Theme.primaryColor
        font.pixelSize: Theme.fontSizeSmall;
        text: "["+stationcount+"]"
    }
}
